//+----------------------------------------------------------------------------+
//|                                                                 qwanya.mq4 |
//|                                                                            |
//|                                                                            |
//+----------------------------------------------------------------------------+
#include       <stdlib.mqh>
extern int     Magic        = 1515;
extern double  Lots         = 1.0;
extern int     Distance     = 150;
double         gd_Distance;
//+----------------------------------------------------------------------------+
//| expert initialization function                                             |
//+----------------------------------------------------------------------------+
int init()
{
//----
    gd_Distance = Distance * Point;
//----
    return (0);
}
//+----------------------------------------------------------------------------+
//| expert deinitialization function                                           |
//+----------------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+----------------------------------------------------------------------------+
//| expert start function                                                      |
//+----------------------------------------------------------------------------+
int start()
{
    int    li_Distance, li_cmd, li_CMD;
    double ld_TP = 0.0, lda_Price[2];
//----
    lda_Price[0] = Bid;
    lda_Price[1] = Ask;
    for (int li_OP = 0; li_OP < 2; li_OP++)
    {
        li_Distance = fDistMarketAndPos (Symbol(), li_OP, Magic);
        if (li_Distance < -Distance)    //        " "
        {
            if (li_OP == OP_BUY) {li_cmd = 1; li_CMD = 1;} else {li_cmd = -1; li_CMD = 0;}
            if (Distance > 0) ld_TP = NormalizeDouble (lda_Price[li_CMD] + li_cmd * gd_Distance, Digits);
            if (OrderSend (Symbol(), li_OP, Lots, NormalizeDouble (lda_Price[li_OP], Digits), 3, 0.0, ld_TP) > 0) OrderPrint();
            else Print ("Error  ", ErrorDescription (GetLastError()));
        }
    }
//----
    return (0);
}
//+----------------------------------------------------------------------------+
//|   :               |
//|                                                                     |
//+----------------------------------------------------------------------------+
int fDistMarketAndPos (string fs_Symbol = "",
                       int fi_Type = -1,
                       int fi_MG = -1)
{
    double ld_Distance, ld_Point, ld_Price = 0.0;
    int    li_cmd, li_Total = OrdersTotal(), li_Distance = EMPTY_VALUE;
//----
    if (fs_Symbol == "" || fs_Symbol == "0") fs_Symbol = Symbol();
    ld_Point = MarketInfo (fs_Symbol, MODE_POINT);
    if (ld_Point == 0.0) return (EMPTY_VALUE);
    for (int li_pos = 0; li_pos < li_Total; li_pos++)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != fs_Symbol) continue;
        if (fi_MG >= 0) if (OrderMagicNumber() != fi_MG) continue;
        if (fi_Type >= 0) if (OrderType() != fi_Type) continue;
        if (OrderType() % 2 == 0) {ld_Price = MarketInfo (fs_Symbol, MODE_BID); li_cmd = 1;}
        else {ld_Price = MarketInfo (fs_Symbol, MODE_ASK); li_cmd = -1;}
        ld_Distance = li_cmd * (ld_Price - OrderOpenPrice()) / ld_Point;
        if (li_Distance > ld_Distance) li_Distance = NormalizeDouble (ld_Distance, 0);
    }
//----
    return (li_Distance);
}
//+----------------------------------------------------------------------------+

